
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.UI.Extensions";

import "RogidorPlugins.MountCarousel(Men and Elves)";

edgePadding = 50;

function LoadSettings()

settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "MountCarouselSettings" );

	if ( type( settings ) ~= "table" ) then
		settings = { };
	end
	
	if ( not settings.welcome ) then
		settings.welcome = false;
	end

	if ( not settings.positionX ) then		
		settings.positionX = ( Turbine.UI.Display.GetWidth() - mainWindow:GetWidth() - edgePadding);		
	end
	
	if ( not settings.positionY ) then	
		settings.positionY = ( Turbine.UI.Display.GetHeight() - mainWindow:GetHeight() - edgePadding * 1.5 );
	end
	
	if ( not settings.alwayshide ) then
		settings.alwayshide = false;
	end
	
	if ( not settings.goat ) then
		settings.goat = false;
	end
	
	if ( not settings.qs1 ) then
		settings.qs1 = 0;
	end
	
	if ( not settings.qs2 ) then
		settings.qs2 = 1;
	end
	
	if ( not settings.qs3 ) then
		settings.qs3 = 2;
	end

	if ( not settings.cqs1 ) then
		settings.cqs1 = 0;
	end
	
	if ( not settings.cqs2 ) then
		settings.cqs2 = 1;
	end
	
	if ( not settings.cqs3 ) then
		settings.cqs3 = 2;
	end

end

function SaveSettings()

Turbine.PluginData.Save( Turbine.DataScope.Character, "MountCarouselSettings", settings );

end

--mainWindow = Turbine.UI.Lotro.Window();
mainWindow = Turbine.UI.Extensions.Window();
mainWindow:SetSize( 200 , 35 );
mainWindow:SetText("Mounts");
mainWindow:SetOpacity( 0 );
mainWindow:SetFadeSpeed( 0.5 );
mainWindow:SetVisible( true );

LoadSettings();

mainWindow:SetPosition(settings.positionX, settings.positionY);

--local displayWidth, displayHeight = Turbine.UI.Display.GetSize();
--local windowWidth,windowHeight = mainWindow:GetSize();

--mainWindow:SetPosition((displayWidth-windowWidth)/2,(displayHeight - windowHeight)/2);

leftWindow = Turbine.UI.Extensions.SimpleWindow();
leftWindow:SetSize( 35 , 35 );
leftWindow:SetParent( mainWindow );
leftWindow:SetPosition( 47.5, 50 );
leftWindow:SetOpacity( 0.25 );
leftWindow:SetFadeSpeed( 0.5 );

centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 35 , 35 );
centerWindow:SetParent( mainWindow );
centerWindow:SetPosition( 82.5, 40 );

rightWindow = Turbine.UI.Extensions.SimpleWindow();
rightWindow:SetSize( 35 , 35 );
rightWindow:SetParent( mainWindow );
rightWindow:SetPosition( 117.5, 50 );
rightWindow:SetOpacity( 0.25 );
rightWindow:SetFadeSpeed( 0.5 );

steeddata = { };


steeddata[0] = "0x7001BFFE"; -- Bree-Starter Horse
steeddata[1] = "0x7001B4B7"; -- Bay Horse
steeddata[2] = "0x7001B4C9"; -- Blonde Sorrel Horse
steeddata[3] = "0x7001B4B0"; -- Bloodbay Horse
steeddata[4] = "0x7001B4C5"; -- Chestnut Horse
steeddata[5] = "0x7001B4A8"; -- Springfest Horse
steeddata[6] = "0x70020550"; -- Blue Roan Horse
steeddata[7] = "0x7001B4C7"; -- Lithe Festival Horse
steeddata[8] = "0x700216F9"; -- Pale Golden Summer Horse
steeddata[9] = "0x7001B4C0"; -- Harvestmath Horse
steeddata[10] = "0x7001B4CD"; -- Yule Festival Horse
steeddata[11] = "0x7001E8EE"; -- Yule Festival Snow Horse
steeddata[12] = "0x7001CF5D"; -- Liver Chestnut Horse
steeddata[13] = "0x7001B4AC"; -- Dark Chestnut Horse
steeddata[14] = "0x7001B4D3"; -- Tundra-Horse
steeddata[15] = "0x7001B4C4"; -- Ashen Horse
steeddata[16] = "0x7001B4D9"; -- Grey Horse
steeddata[17] = "0x7001B4D0"; -- Galadhrim Horse
steeddata[18] = "0x7002054D"; -- Smoky Black Horse
steeddata[19] = "0x70022C61"; -- Horse of the Grey Company
steeddata[20] = "0x7001E97D"; -- Dunedain War-Horse
steeddata[21] = "0x7001B4B1"; -- Mahogany Bay Horse
steeddata[22] = "0x7001E980"; -- Galadhrim War-Horse
steeddata[23] = "0x7001E8ED"; -- Sable Harvestmath Horse
steeddata[24] = "0x7001B4C1"; -- Bree Horse

steedqs = { };

for i = 0, 24 do

	steedqs[i] = Turbine.UI.Lotro.Quickslot();
	steedqs[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( 6.0, steeddata[i] ) );

end

goatdata = { };

goatdata[0] = "0x7001CEAA"; -- Dusky Nimblefoot Goat
goatdata[1] = "0x7001B4B4"; -- Tame Redhorn Goat 
goatdata[2] = "0x7001B4B8"; -- Nimble Redhorn-Goat
goatdata[3] = "0x7001E981"; -- Nimble Black Goat
goatdata[4] = "0x7001E97A"; -- Wild Mountain Goat

goatqs = { };

for i = 0, 4 do

	goatqs[i] = Turbine.UI.Lotro.Quickslot();
	goatqs[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( 6.0, goatdata[i] ) );

end

leftqs = Turbine.UI.Lotro.Quickslot();
leftqs:SetParent( leftWindow );
leftqs:SetPosition( 0, 0 );
leftqs:SetSize( 35, 35 );
leftqs:SetAllowDrop(false);

centerqs = Turbine.UI.Lotro.Quickslot();
centerqs:SetParent( centerWindow );
centerqs:SetPosition( 0, 0 );
centerqs:SetSize( 35, 35 );
centerqs:SetAllowDrop(false);

rightqs = Turbine.UI.Lotro.Quickslot();
rightqs:SetParent( rightWindow );
rightqs:SetPosition( 0, 0 );
rightqs:SetSize( 35, 35 );
rightqs:SetAllowDrop(false);

qs1 = settings.qs1;
qs2 = settings.qs2;
qs3 = settings.qs3;
cqs1 = settings.cqs1;
cqs2 = settings.cqs2;
cqs3 = settings.cqs3;

goat = settings.goat;

if (goat == false) then

	leftqs:SetShortcut(steedqs[qs1]:GetShortcut());
	centerqs:SetShortcut(steedqs[qs2]:GetShortcut());
	rightqs:SetShortcut(steedqs[qs3]:GetShortcut());

else

	leftqs:SetShortcut(goatqs[cqs1]:GetShortcut());
	centerqs:SetShortcut(goatqs[cqs2]:GetShortcut());
	rightqs:SetShortcut(goatqs[cqs3]:GetShortcut());

end

if ( settings.welcome == false ) then
	Turbine.Shell.WriteLine(" *** Welcome to Mount Carousel! ***\n - To show help type /mc help");
end

MountCarouselCommand = Turbine.ShellCommand();

function MountCarouselCommand:Execute( command, arguments )

	if ( arguments == "help" ) then
		Turbine.Shell.WriteLine(" *** Mount Carousel Help ***\n\n - Use the Mouse Wheel over the middle Shortcut to move the Carousel\n - Right click the middle Shortcut to change between Steed and Goat Carousels\n - Right click anywhere in the window to hide it. \n -Use the command '/mc' or '/mountcarousel' to hide or show the Plugin.\n - Use the command '/mc restore' to move the window to its default position.\n - Use the command '/mc welcomeoff' to turn off the welcome message.\n - Use the command '/mc welcomeon' to turn on the welcome message.");
	elseif ( arguments == "welcomeoff" ) then
		settings.welcome = true;
		SaveSettings();
		Turbine.Shell.WriteLine("Welcome message has been disabled");
	elseif (arguments == "welcomeon" ) then
		settings.welcome = false;
		SaveSettings();
		Turbine.Shell.WriteLine("Welcome message has been enabled");
	elseif ( arguments == "restore" ) then
		settings.positionX = ( Turbine.UI.Display.GetWidth() - mainWindow:GetWidth() - edgePadding);		
		settings.positionY = ( Turbine.UI.Display.GetHeight() - mainWindow:GetHeight() - edgePadding * 1.5 );
		mainWindow:SetPosition(settings.positionX, settings.positionY);
		SaveSettings();
		Turbine.Shell.WriteLine("Window restored to its default position");
	elseif ( arguments ~= nil ) then
		mainWindow:SetVisible( not mainWindow:IsVisible() );
	end

end

Turbine.Shell.AddCommand( "mc;mountcarousel", MountCarouselCommand );

mainWindow.MouseEnter = function( sender, args )

if (alwayshide == false) then
	mainWindow:SetOpacity( 0.75 );
end

rightWindow:SetOpacity( 0.75 );
leftWindow:SetOpacity( 0.75 );

end

mainWindow.MouseLeave = function( sender, args )

X, Y = mainWindow:GetPosition();

if (alwayshide == false) then
	mainWindow:SetOpacity( 0 );
end

rightWindow:SetOpacity( 0.25 );
leftWindow:SetOpacity( 0.25 );

if ( X ~= settings.positionX or Y ~= settings.positionY ) then
		
	settings.positionX = X;
	settings.positionY = Y;
	SaveSettings();
		
end

end

alwayshide = settings.alwayshide;

mainWindow.MouseClick = function (sender, args)

if ( args.Button == Turbine.UI.MouseButton.Right ) then

	if (alwayshide == false ) then
		mainWindow:SetOpacity ( 0 );
		alwayshide = true;
	else
		mainWindow:SetOpacity( 0.75 );
		alwayshide = false;
	end
	
	settings.alwayshide = alwayshide;
	SaveSettings();

end

end

centerqs.MouseClick = function (sender, args)

if ( args.Button == Turbine.UI.MouseButton.Right ) then

	if (goat == false) then

		leftqs:SetShortcut(goatqs[cqs1]:GetShortcut());
		centerqs:SetShortcut(goatqs[cqs2]:GetShortcut());
		rightqs:SetShortcut(goatqs[cqs3]:GetShortcut());
		goat = true;

	else

		leftqs:SetShortcut(steedqs[qs1]:GetShortcut());
		centerqs:SetShortcut(steedqs[qs2]:GetShortcut());
		rightqs:SetShortcut(steedqs[qs3]:GetShortcut());
		goat = false;

	end
	
	settings.goat = goat;
	SaveSettings();

end

end

centerqs.MouseWheel = function( sender, args )

	Carousel();

end

centerqs.MouseLeave = function( sender, args)

if ( settings.qs1 ~= qs1 or settings.cqs1 ~= cqs1 ) then

	settings.qs1 = qs1;
	settings.qs2 = qs2;
	settings.qs3 = qs3;

	settings.cqs1 = cqs1;
	settings.cqs2 = cqs2;
	settings.cqs3 = cqs3;

	SaveSettings();
	
end

end

function Carousel()

if (goat == false) then

	qs1 = qs1 + 1;
	qs2 = qs2 + 1;
	qs3 = qs3 + 1;

	if (qs1 == 25) then
		qs1 = 0;
	elseif (qs2 == 25) then
		qs2 = 0;
	elseif (qs3 == 25) then
		qs3 = 0;
	end

	leftqs:SetShortcut(steedqs[qs1]:GetShortcut());
	centerqs:SetShortcut(steedqs[qs2]:GetShortcut());
	rightqs:SetShortcut(steedqs[qs3]:GetShortcut());

else

	cqs1 = cqs1 +1;
	cqs2 = cqs2 +1;
	cqs3 = cqs3 +1;

	if (cqs1 == 5) then
		cqs1 = 0;
	elseif (cqs2 == 5) then
		cqs2 = 0;
	elseif (cqs3 == 5) then
		cqs3 = 0;
	end

	leftqs:SetShortcut(goatqs[cqs1]:GetShortcut());
	centerqs:SetShortcut(goatqs[cqs2]:GetShortcut());
	rightqs:SetShortcut(goatqs[cqs3]:GetShortcut());

end

end